local interaction_classes = {
	--"BaseInteractionExt",
	-- "MultipleChoiceInteractionExt",
	-- "GageAssignmentInteractionExt",
	-- "SmallLootInteractionExt",
	-- "MoneyWrapInteractionExt",
	-- "DiamondInteractionExt",
	-- "LootBankInteractionExt",
	-- "EventIDInteractionExt",
	-- "MissionDoorDeviceInteractionExt",
	-- "MissionElementInteractionExt"
}

local value_start = 10
local value_multiplier = 10

local spawn_offset = 50
local velocity_multiplier = 0.3

for _, interaction_class in pairs(interaction_classes) do
	log(tostring(interaction_class))
	Hooks:PostHook(_G[interaction_class], "interact", "LegoStudInteract" .. interaction_class, function(self, player)
		local timer = self:_timer_value() or 0
		local stud_value = value_start + (timer * value_multiplier)

		local position = self:interact_position() or self._unit:position()
		local direction = self:interact_axis() or math.UP
		local offset = direction * spawn_offset

		log(tostring(self:interact_axis()))
		log(tostring(self:interact_position()))

		log(tostring(self._unit:rotation():y()))

		managers.stud:spawn_studs(stud_value, position + offset, velocity_multiplier, direction)
	end)
end