ContractBrokerHeistItem.stud_indicator_data = {
    texture = "guis/lego_studs/true_heister",
    off_rect = {
        0,
        0,
        64,
        64
    },
    on_rect = {
        576,
        0,
        64,
        64
    }
}

Hooks:PostHook(ContractBrokerHeistItem, "init", "LegoStudsBrokerItem", function(self, parent_panel, job_data, idx)
    if self._image_panel then
        local padding = 2 
        local lego_stud_indicator_bitmap = self._image_panel:bitmap({
            h = 32,
            w = 32,
            layer = 3,
            texture = self.stud_indicator_data.texture,
            alpha = 0.8
        })

        lego_stud_indicator_bitmap:set_bottom(self._image_panel:bottom() - 12)
        lego_stud_indicator_bitmap:set_left(self._image_panel:left() + padding)

        local true_heister = managers.stud_storage:get_true_heister_for_job_id(self._job_data.job_id)
        local rect = true_heister and self.stud_indicator_data.on_rect or self.stud_indicator_data.off_rect

        lego_stud_indicator_bitmap:set_texture_rect(rect[1], rect[2], rect[3], rect[4])
    end
end)